/////////////////////////////////////////////////////////////////////////////
// GLOBAL_DEFS.H
/////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <Wingdi.h>

#include "d3d9.h"
#include "d3dx9xof.h"
#include "d3dx9.h"

// general stuff - my definitions
#define SAFERELEASE(p) if (p) {(p)->Release(); (p) = NULL;}
#define SAFEDELETE(p) if (p) {delete(p); (p) = NULL;}
#define SAFEDELETE_ARRAY(p) if (p) {delete[](p); (p) = NULL;}

#define MIN(a, b) ((a) < (b) ? (a) : (b))						
#define MAX(a, b) ((a) > (b) ? (a) : (b))

#define PI 3.1415926535f	

#define DEGTORAD(x) ((x) * PI / 180.0f)
#define RADTODEG(x) ((x) * 180.0f / PI)

// Overloaded Debug functions. CarriageReturn must be given by caller !
inline void DB(char* pInfo, float fVal)
{
    //#ifdef _DEBUG 
    char buffer[MAX_PATH];
    sprintf(buffer,"%s %.3f",pInfo,fVal);
    OutputDebugString(buffer);
    //#endif
}

inline void DB(char* pInfo, int iVal)
{
    //#ifdef _DEBUG 
    char buffer[MAX_PATH];
    sprintf(buffer,"%s %i",pInfo,iVal);
    OutputDebugString(buffer);
    //#endif
}

inline void DB(char* pInfo)
{
    //#ifdef _DEBUG 
    OutputDebugString(pInfo);
    //#endif
}

// File Version. Resource (version) must be changed, too !
#define GP_DLLVERSION 1.5
#define GP_COMMSVERSION 1.5

// User-defined command sent by the keybhook dll
#define CM_COMMAND_KEY  (WM_USER + 0x1000)

// sub-struct for more than one ingame textlines
struct SL_BLOBstruct
{
	// Single Line Text Functions
    BYTE            cSL_ShowIt;
    WORD            wSL_TextPosX;
    WORD            wSL_TextPosY;
    BYTE            cSL_TextSize;
    BYTE            cSL_TextBold;
    D3DCOLOR        sSL_TextColor;
    BYTE            cSL_FontFamily;
    BYTE            cSL_TextBlackBackground;
	char            cSL_LineData[128];
};

struct ML_BLOBstruct
{
	// Multiline Text Functions
    BYTE            cML_ShowIt;
    WORD            wML_PosX;
    WORD            wML_PosY;
    D3DCOLOR        dwML_TextColor;
    BYTE            cML_BlackBackground;
    WORD            wML_SizeX;
    WORD            wML_SizeY;
    BYTE            cML_FontSize;
	BYTE            cML_TextBold;
    BYTE            cML_FontFamily;
	char            cML_LineData[512];
};


#define GP_NUMBER_OF_TEXTFIELDS_EACH 5

// The control MMF layout
struct CONTROLMMFstruct
{
    // Single Line Text Functions
    SL_BLOBstruct SL_Data[GP_NUMBER_OF_TEXTFIELDS_EACH];

	// Multiline Text Functions
    ML_BLOBstruct ML_Data[GP_NUMBER_OF_TEXTFIELDS_EACH];

	// Picture(from Disk) functions
    BYTE            cPIC_ShowIt;
    BYTE            cPIC_LoadNew;
    WORD            wPIC_PosX;
    WORD            wPIC_PosY;
    char            cPathToPicture[128];

	// Screensize Info Function
	UINT            cSI_iScreenX;
	UINT            cSI_iScreenY;

	// FPS on/off switch
	BYTE            bSI_ShowFPS;

	// Screeshot Functions
	BYTE            bSS_DoScreenshot;
	BYTE            bSS_ScreenshotFormat; //0=bmp,1=jpg
	char            cPathToScreenshot[128];

};
