// gp_demoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "gp_demo.h"
#include "gp_demoDlg.h"
#include ".\gp_demodlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl 'Info'

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cgp_demoDlg Dialogfeld

Cgp_demoDlg::Cgp_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cgp_demoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_hGPDll = NULL;
}

void Cgp_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB1, m_cTabCtrl);
}

BEGIN_MESSAGE_MAP(Cgp_demoDlg, CDialog)
	ON_MESSAGE(CM_COMMAND_KEY, OnHookKeyHandler)
    ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
   	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// Cgp_demoDlg Meldungshandler

BOOL Cgp_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

    m_pGeneralSubDlg  = new CGeneralSubDlg();
	m_pGraphicsSubDlg = new CGraphicsSubDlg();
	m_pMLSubDlg       = new CMLSubDlg();
	m_pSLSubDlg       = new CSLSubDlg();

	m_pGeneralSubDlg->Create(IDD_GENERAL_SUBDIALOG,this);
    m_pGraphicsSubDlg->Create(IDD_GRAPHICS_SUBDIALOG,this);
	m_pMLSubDlg->Create(IDD_ML_SUBDIALOG,this);
	m_pSLSubDlg->Create(IDD_SL_SUBDIALOG,this);

	m_cTabCtrl.DeleteAllItems();
	m_cTabCtrl.InsertItem(0,"General");
	m_cTabCtrl.InsertItem(1,"SingleLine");
	m_cTabCtrl.InsertItem(2,"MultiLine");
	m_cTabCtrl.InsertItem(3,"Graphics");
    
	m_cTabCtrl.SetCurSel(0);

	ShowGeneralSubDlg();
	
	// GPCOMMS.DLL
    m_hGPDll = AfxLoadLibrary("gpcomms.dll");
    if (!m_hGPDll) 
    {
        AfxMessageBox("GPCOMMS.DLL not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

    GPSL_SetTextLineData = (GPSL_SETTEXTLINEDATA) GetProcAddress(m_hGPDll, "GPSL_SetTextLineData"); 
    GPSL_ShowText = (GPSL_SHOWTEXT) GetProcAddress(m_hGPDll, "GPSL_ShowText"); 
    
    if (!GPSL_SetTextLineData ||!GPSL_ShowText) 
    {
        AfxMessageBox("GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

    GPML_SetTextMultilineData = (GPML_SETTEXTMULTILINEDATA) GetProcAddress(m_hGPDll, "GPML_SetTextMultilineData"); 
    GPML_ShowText = (GPML_SHOWTEXT) GetProcAddress(m_hGPDll, "GPML_ShowText"); 
    
    if (!GPML_SetTextMultilineData ||!GPML_ShowText) 
    {
        AfxMessageBox("GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

    GPPIC_LoadNewPicture = (GPPIC_LOADNEWPICTURE) GetProcAddress(m_hGPDll, "GPPIC_LoadNewPicture");
    GPPIC_ShowPicturePos = (GPPIC_SHOWPICTUREPOS) GetProcAddress(m_hGPDll, "GPPIC_ShowPicturePos");

    if (!GPPIC_LoadNewPicture ||!GPPIC_ShowPicturePos) 
    {
        AfxMessageBox("GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

	GPSI_GetScreenSize = (GPSI_GETSCREENSIZE) GetProcAddress(m_hGPDll, "GPSI_GetScreenSize");

    if (!GPSI_GetScreenSize) 
    {
        AfxMessageBox("GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

	GPSI_ShowFPS = (GPSI_SHOWFPS) GetProcAddress(m_hGPDll, "GPSI_ShowFPS");

    if (!GPSI_ShowFPS) 
    {
        AfxMessageBox("GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

	GPSS_MakeScreenshot = (GPSS_MAKESCREENSHOT) GetProcAddress(m_hGPDll, "GPSS_MakeScreenshot");

    if (!GPSS_MakeScreenshot) 
    {
        AfxMessageBox("GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }


    // GPHOOK.DLL
    m_hGPHookDll = AfxLoadLibrary("GPHook.dll");
    if (!m_hGPHookDll) 
    {
        AfxMessageBox("GPHOOK.DLL not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

    GPH_HookOn  = (GPH_HOOKON)  GetProcAddress(m_hGPHookDll, "HookOn");
    GPH_HookOff = (GPH_HOOKOFF) GetProcAddress(m_hGPHookDll, "HookOff");

    if (!GPH_HookOn ||!GPH_HookOff) 
    {
        AfxMessageBox("GPHOOK.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

    GPH_HookOn(this->GetSafeHwnd(),false);

    return(true);  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void Cgp_demoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void Cgp_demoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR Cgp_demoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL Cgp_demoDlg::DestroyWindow()
{
    // the communications wrapper dll
    if (m_hGPDll) 
    {
        AfxFreeLibrary(m_hGPDll);
        m_hGPDll = NULL;
    }    

    // the keyboard hook
    if (m_hGPHookDll) 
    {
        GPH_HookOff();
        AfxFreeLibrary(m_hGPHookDll);
        m_hGPDll = NULL;
    }

	if (m_pGeneralSubDlg) delete(m_pGeneralSubDlg);
	if (m_pGraphicsSubDlg) delete(m_pGraphicsSubDlg);
	if (m_pMLSubDlg) delete(m_pMLSubDlg);
	if (m_pSLSubDlg) delete(m_pSLSubDlg);

    return CDialog::DestroyWindow();
}

LRESULT Cgp_demoDlg::OnHookKeyHandler(WPARAM wParam, LPARAM lParam)
{
    if (wParam == VK_INSERT) 
    {
        if (GetKeyState(VK_INSERT)&(0x0001<<7))
        {
            static bool bIsActive = false;
			bIsActive = (!bIsActive);
			
			for (BYTE i=0;i<5;i++)
			{
				GPSL_ShowText(i,bIsActive);
			}
			
			m_pGeneralSubDlg->m_sRecKeyList += "VK_INSERT\r\n";
			m_pGeneralSubDlg->UpdateData(false);			
        }
    }

    if (wParam == VK_HOME) 
    {
        if (GetKeyState(VK_HOME)&(0x0001<<7))
        {
            static bool bIsActive = false;
			bIsActive = (!bIsActive);
			
			for (BYTE i=0;i<5;i++)
			{
				GPML_ShowText(i,bIsActive);
			}

			m_pGeneralSubDlg->m_sRecKeyList += "VK_HOME\r\n";
			m_pGeneralSubDlg->UpdateData(false);
        }
    }

	if (wParam == VK_END) 
	{
		if (GetKeyState(VK_END)&(0x0001<<7))
        {
            static bool bIsActive = false;
			bIsActive = (!bIsActive);
			GPPIC_ShowPicturePos(bIsActive,10,10);
					
			m_pGeneralSubDlg->m_sRecKeyList += "VK_END\r\n";
			m_pGeneralSubDlg->UpdateData(false);
        }
    }

	if (wParam == VK_DELETE) 
	{
		if (GetKeyState(VK_DELETE)&(0x0001<<7))
        {
			bool bFormat = (m_pGraphicsSubDlg->m_cSSFormat.GetCheck()==BST_CHECKED?false:true);

			GPSS_MakeScreenshot(bFormat,(LPCTSTR)m_pGraphicsSubDlg->m_sScreenshotPath);
					
			m_pGeneralSubDlg->m_sRecKeyList += "VK_DELETE\r\n";
			m_pGeneralSubDlg->UpdateData(false);
        }
    }

    return(0);
}

void Cgp_demoDlg::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;

	int iSel = m_cTabCtrl.GetCurSel();

	switch (iSel)
	{
		case 0: ShowGeneralSubDlg(); break;
		case 1: ShowSLSubDlg(); break;
		case 2: ShowMLSubDlg(); break;
		case 3: ShowGraphicsSubDlg(); break;
	}
}

void Cgp_demoDlg::ShowGeneralSubDlg(void)
{
	m_pGeneralSubDlg->ShowWindow(true);
	m_pGraphicsSubDlg->ShowWindow(false);
	m_pMLSubDlg->ShowWindow(false);
	m_pSLSubDlg->ShowWindow(false); 
}

void Cgp_demoDlg::ShowGraphicsSubDlg(void)
{
	m_pGeneralSubDlg->ShowWindow(false);
	m_pGraphicsSubDlg->ShowWindow(true);
	m_pMLSubDlg->ShowWindow(false);
	m_pSLSubDlg->ShowWindow(false); 
}

void Cgp_demoDlg::ShowMLSubDlg(void)
{
	m_pGeneralSubDlg->ShowWindow(false);
	m_pGraphicsSubDlg->ShowWindow(false);
	m_pMLSubDlg->ShowWindow(true);
	m_pSLSubDlg->ShowWindow(false); 
}

void Cgp_demoDlg::ShowSLSubDlg(void)
{
	m_pGeneralSubDlg->ShowWindow(false);
	m_pGraphicsSubDlg->ShowWindow(false);
	m_pMLSubDlg->ShowWindow(false);
	m_pSLSubDlg->ShowWindow(true); 
}


